'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var CryptoJS = require('crypto-js');
var Stream = require('readable-stream');

var ProgressiveCryptor = function () {
  function ProgressiveCryptor(state, secretKey) {
    _classCallCheck(this, ProgressiveCryptor);

    var salt = CryptoJS.lib.WordArray.random(8);
    var cipher = CryptoJS.kdf.OpenSSL.execute(secretKey, 8, 4, salt);

    this.state = state;
    this.key = CryptoJS.enc.Utf8.parse(secretKey);

    this.cryptorParams = {
      iv: cipher.iv
    };
  }

  _createClass(ProgressiveCryptor, [{
    key: 'start',
    value: function start() {
      var _this = this;

      new Promise(function (resolve, reject) {
        try {
          (function () {
            var stream = new Stream();
            var processedState = '';

            stream.on('data', function (data) {
              processedState += _this.processor.process(data.toString());
            }).on('end', function () {
              processedState += _this.processor.finalize();
              resolve(processedState);
            });

            stream.push(_this.state);
            stream.push(null);
          })();
        } catch (err) {
          reject(err);
        }
      });
    }
  }, {
    key: 'encrypt',
    value: function encrypt() {
      this.processor = CryptoJS.algo.AES.createEncryptor(this.key, this.cryptorParams);
      this.start();
    }
  }, {
    key: 'decrypt',
    value: function decrypt() {
      this.processor = CryptoJS.algo.AES.createDecryptor(this.key, this.cryptorParams);
      this.start();
    }
  }]);

  return ProgressiveCryptor;
}();

exports.default = ProgressiveCryptor;